cbuffer cbPerFrame : register(b0)
{
	float4x4 matVP;
	float4x4 matGeo;
	float3 objColor;
};

struct VSInput
{
	float3 Position : POSITION;
	float3 Normal : NORMAL;
	float2 UV : TEXCOORD;
	float3 Tangent : TANGENT;
	float3 Btangent : BTANGENT;
};

struct VSOutput
{
	float4 Position : SV_POSITION;
	float4 PosInWorld : TEXCOORD0;
	float4 Color : COLOR;
	float3 Normal : NORMAL;
	float2 UV : TEXCOORD;
	float3x3 TBN;
};
		
VSOutput main(VSInput vin)
{
	VSOutput vout = (VSOutput)0;
	
	vout.Position = mul(mul(float4(vin.Position, 1), matGeo), matVP);
	vout.PosInWorld = mul(float4(vin.Position, 1), matGeo);
	vout.Normal = mul(vin.Normal, (float3x3)matGeo);
	vout.Color = float4(objColor, 1);
	vout.UV = vin.UV;
	
   float3 T = normalize(float3(mul(float4(vin.Tangent,   0.0), matGeo)));
   float3 B = normalize(float3(mul(float4(vin.Btangent, 0.0), matGeo)));
   float3 N = normalize(float3(mul(float4(vin.Normal,    0.0), matGeo)));
   vout.TBN = float3x3(T,B,N);
	
	return vout;
}